import assert from 'assert'
import math from '#nanomath'
import {Type} from '#core/Type.js'

const boolean = math.boolean

describe('boolean type functions', () => {
   it('properly converts to boolean', () => {
      assert.strictEqual(boolean(false), false)
      assert.strictEqual(boolean(true), true)
      assert.strictEqual(boolean(0), false)
      assert.strictEqual(boolean(-0), false)
      assert.strictEqual(boolean(NaN), false)
      assert.strictEqual(boolean(Infinity), true)
      assert.strictEqual(boolean(1e-30), true)
      assert.strictEqual(boolean(undefined), false)
      assert.strictEqual(boolean(), false)
      assert.strictEqual(boolean(math.types.NumberT), true)
   })
   it('converts any type to boolean', () => {
      for (const T in math.types) {
         if (T instanceof Type) assert(boolean.resolve([T]))
      }
   })       
})
