import assert from 'assert'
import {NumberT} from '../NumberT.js'
import {BooleanT} from '#boolean/BooleanT.js'
import math from '#nanomath'

describe('NumberT Type', () => {
   it('correctly recognizes numbers', () => {
      assert(NumberT.test(3))
      assert(NumberT.test(NaN))
      assert(NumberT.test(Infinity))
      assert(!NumberT.test("3"))
   })

   it('can convert from BooleanT to NumberT', () => {
      const convertImps = NumberT.from
      let cnvBtoN
      for (const [pattern, convFactory] of convertImps.patterns) {
         if (pattern.match([BooleanT])) {
            cnvBtoN = convFactory(math)
            break
         }
      }
      assert.strictEqual(cnvBtoN(true), 1)
      assert.strictEqual(cnvBtoN(false), 0)
   })
})
