import {plain} from './helpers.js'

export const abs = plain(Math.abs)
export const absquare = plain(a => a*a)
export const add = plain((a, b) => a + b)
export const divide = plain((a, b) => a / b)
export const cbrt = plain(a => {
   if (a === 0) return a
   const negate = a < 0 
   if (negate) a = -a
   let result = a
   if (isFinite(a)) {
      result = Math.exp(Math.log(result) / 3)
      result = (a / (result * result) + (2 * result)) / 3
   }
   return negate ? -result : result
})
export const invert = plain(a => 1/a)
export const multiply = plain((a, b) => a * b)
export const negate = plain(a => -a)
export const subtract = plain((a, b) => a - b)
export const quotient = plain((a,b) => Math.floor(a/b))
